// Decompiled by Jad v1.5.7c. Copyright 1997-99 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/SiliconValley/Bridge/8617/jad.html
// Decompiler options: packfields(5) packimports(3) nocasts braces 
// Source File Name:   Fortune.java

import java.awt.*;
import java.awt.event.*;
import java.util.Vector;

class MyCanvas extends Canvas
	implements MouseListener, KeyListener
{
	Graphics offScreenGraphics;
	Image offScreenImage;
	int XPos;
	VoronoiClass voronoi, prevVoronoi;
	DelaunayClass Delaunay;
	boolean drawCircles, drawBeach, drawVoronoiLines, drawDelaunay, drawHistory;
	EventQueue Events;
	ArcTree Arcs;

	public MyCanvas(int i, int j, int k)
	{
		drawCircles = false;
		drawBeach = false;
		drawVoronoiLines = true;
		drawDelaunay = false;
		drawHistory = false;
		addMouseListener(this);
		addKeyListener(this);
		voronoi = new VoronoiClass(i, j, k);
	}

	public synchronized void init()
	{
		offScreenImage = createImage(getBounds().width, getBounds().height);
		offScreenGraphics = offScreenImage.getGraphics();
		XPos = 0;
		Arcs = new ArcTree();
		Events = new EventQueue();
		voronoi.clear();
		Delaunay = new DelaunayClass();
		//for(int i = 0; i < voronoi.size(); i++)
		//{
		//	Events.insert(new EventPoint((MyPoint)voronoi.elementAt(i)));
		//}
	}

	public synchronized void initVoronoi() {
		Arcs = new ArcTree();
		Events = new EventQueue();
		voronoi.clear();
		Delaunay = new DelaunayClass();
		for(int i = 0; i < voronoi.size(); i++) {
			Events.insert(new EventPoint((MyPoint)voronoi.elementAt(i)));
		}
	}
	
	public void mouseClicked(MouseEvent mouseevent)
	{
	}

	public void mouseReleased(MouseEvent mouseevent)
	{
	}

	public void mouseEntered(MouseEvent mouseevent)
	{
	}

	public void mouseExited(MouseEvent mouseevent)
	{
	}

	public synchronized void mousePressed(MouseEvent mouseevent)
	{
		MyPoint mypoint = new MyPoint(mouseevent.getPoint());
		if(mypoint.x > (double)XPos)
		{
			voronoi.addElement(mypoint);
			voronoi.checkDegenerate();
			Events.insert(new EventPoint(mypoint));
			repaint();
		}
	}

	public void addNow(double yPerc) {
		double y = this.getHeight() * yPerc;
		MyPoint myPoint = new MyPoint(XPos * 1.0, y);
		voronoi.addElement(myPoint);
		voronoi.checkDegenerate();
		Events.insert(new EventPoint(myPoint));
		repaint();
	}
	
	public synchronized void paint(Graphics g)
	{
		g.setColor(Color.black);
		g.fillRect(0, 0, getBounds().width, getBounds().height);

		if (drawHistory && prevVoronoi != null) {
			g.setColor(Color.darkGray);
			prevVoronoi.paint(g, drawVoronoiLines);
		}

		g.setColor(Color.white);
		voronoi.paint(g, drawVoronoiLines);
		
		g.setColor(Color.gray);
		g.drawLine(XPos, 0, XPos, getBounds().height);
		if(Events != null && Arcs != null)
		{
			g.setColor(Color.gray);
			Events.paint(g, drawCircles);
			Arcs.paint(g, XPos, drawVoronoiLines, drawBeach);
		}
		if(drawDelaunay)
		{
			g.setColor(Color.gray);
			Delaunay.paint(g);
		}
	}

	public void update(Graphics g)
	{
		offScreenGraphics.setClip(g.getClipBounds());
		paint(offScreenGraphics);
		g.drawImage(offScreenImage, 0, 0, this);
//		paint(g);
	}

	public synchronized boolean singlestep ()
	{
		if(Events.Events == null || (double)XPos < Events.Events.x)
			XPos++;

		while(Events.Events != null && (double)XPos >= Events.Events.x) 
		{
			EventPoint eventpoint = Events.pop();
			XPos = Math.max(XPos, (int)eventpoint.x);
			eventpoint.action(this);
			Arcs.checkBounds(this, XPos);
		}

		if(XPos > getBounds().width && Events.Events == null)
			Arcs.checkBounds(this, XPos);

		repaint();
		return Events.Events != null || XPos < 1000 + getBounds().width;
	}

	public synchronized void step()
	{
		EventPoint eventpoint = Events.pop();
		if(eventpoint != null)
		{
			XPos = Math.max(XPos, (int)eventpoint.x);
			eventpoint.action(this);
		} else
		if(XPos < getBounds().width)
		{
			XPos = getBounds().width;
		} else
		{
			init();
		}
		Arcs.checkBounds(this, XPos);
		repaint();
	}

	public synchronized void clear()
	{
		prevVoronoi = voronoi;
		voronoi = new VoronoiClass(getBounds().width, getBounds().height, 0);
		restart();
	}

	public synchronized void restart()
	{
		init();
		repaint();
	}

	public void keyPressed(KeyEvent e) {		
	}

	public void keyReleased(KeyEvent e) {
	}

	public void keyTyped(KeyEvent e) {
		System.out.println("aha");
		if (e.getKeyChar() == 'v') {
			drawVoronoiLines = !drawVoronoiLines;
		}
		else if(e.getKeyChar() == 'b') {
			drawBeach = ! drawBeach;
		}
		else if (e.getKeyChar() == 'c') {
			drawCircles = ! drawCircles;
		}
		else if (e.getKeyChar() == 'd') {
			drawDelaunay = ! drawDelaunay;
		}
		else if (e.getKeyChar() == 'h') {
			drawHistory = ! drawHistory;
		}
	}

}
